<template>
  <div>
    <div class="row q-pb-md">
      <div class="col">
        <q-btn color="primary" icon="add" label="Create Room" @click="addRoom" />
      </div>
    </div>
    <div class="row">
      <div class="col">
        <q-table
          :columns="cols"
          :rows="rooms"
          row-key="id"
          @row-click="onClick"
        />
      </div>
    </div>
    <q-dialog v-model="showRoom" v-if="room">
      <q-card>
        <q-card-section>
          <div class="text-h6">Room</div>
        </q-card-section>

        <q-card-section class="q-pt-none">
          <q-list>
            <q-item>
              <q-item-section>
                <q-item-label caption>ID</q-item-label>
                <q-item-label class="q-ml-sm">{{ room.id }}</q-item-label>
              </q-item-section>
            </q-item>
            <q-item>
              <q-item-section>
                <q-item-label caption>Name</q-item-label>
                <q-item-label class="q-ml-sm">{{ room.name }}</q-item-label>
              </q-item-section>
            </q-item>
            <q-item>
              <q-item-section>
                <q-item-label caption>Description</q-item-label>
                <q-item-label class="q-ml-sm">{{ room.description }}</q-item-label>
              </q-item-section>
            </q-item>
            <q-item>
              <q-item-section>
                <q-item-label caption>Start At</q-item-label>
                <q-item-label class="q-ml-sm">{{ startToLocaleString }}</q-item-label>
              </q-item-section>
            </q-item>
            <q-item>
              <q-item-section>
                <q-item-label caption>End At</q-item-label>
                <q-item-label class="q-ml-sm">{{ endToLocaleString }}</q-item-label>
              </q-item-section>
            </q-item>
          </q-list>
        </q-card-section>

        <q-card-actions align="right">
          <q-btn
            flat
            label="Start Meeting"
            color="red"
            :to="{ name: 'room', params: { id: room.id }}"
          />
          <q-btn flat label="Edit" color="primary" :to="{ name: 'edit-room' }" />
          <q-btn flat label="Close" color="primary" v-close-popup />
        </q-card-actions>
      </q-card>
    </q-dialog>
  </div>
</template>

<script lang="ts">
import {
  computed,
  defineComponent, onMounted, Ref, ref,
} from 'vue';
import { api } from 'boot/axios';
import { useRoomStore, Room } from 'stores/room';
import { QTableColumn } from 'quasar';
import { storeToRefs } from 'pinia';
import { useRouter } from 'vue-router';

const showRoom = ref(false);
const roomStore = useRoomStore();
const { room, rooms } = storeToRefs(roomStore);
const { refresh } = roomStore;

function onClick(event: Event, row: Room) {
  room.value = row;
  showRoom.value = true;
}

export default defineComponent({
  name: 'RoomsTable',
  setup() {
    const router = useRouter();

    const cols: Array<QTableColumn> = [
      {
        name: 'id', label: 'ID', field: 'id', align: 'left',
      },
      {
        name: 'name', label: 'Name', field: 'name', align: 'center',
      },
      {
        name: 'start_at',
        label: 'Start At',
        field: (row) => (row.start_at ? new Date(row.start_at).toLocaleString() : ''),
        align: 'center',
      },
      {
        name: 'end_at',
        label: 'End At',
        field: (row) => (row.end_at ? new Date(row.end_at).toLocaleString() : ''),
      },
    ];
    const authenticated: Ref<boolean | null> = ref(null);
    onMounted(() => {
      if (api.isAuthenticated()) {
        authenticated.value = true;
        refresh();
      }
    });

    const startToLocaleString = computed(() => (room.value?.start_at ? new Date(room.value.start_at).toLocaleString() : ''));
    const endToLocaleString = computed(() => (room.value?.end_at ? new Date(room.value.end_at).toLocaleString() : ''));

    function addRoom() {
      room.value = {
        name: '',
        description: '',
        start_at: new Date(),
        end_at: new Date(),
        access: 'CEU',
      };
      router.push({ name: 'new-room' });
    }

    return {
      showRoom,
      authenticated,
      cols,
      rooms,
      room,
      onClick,
      startToLocaleString,
      endToLocaleString,
      addRoom,
    };
  },
});
</script>
